@echo off
set curlver=8.2.1_7
if not exist C:\Windows\System32\curl.exe if not exist %cd%\curl.exe (
  bitsadmin /transfer curlDownload https://curl.se/windows/dl-%curlver%/curl-%curlver%-win32-mingw.zip %cd%\curl.zip
  call :UnZipFile "%cd%" "%cd%\curl.zip"
  move curl-%curlver%-win32-mingw\bin\curl.exe curl.exe
  rmdir /s /q curl-%curlver%-win32-mingw
)

REM BITS requires the HTTP server to return the Content-Length header
set URL=https://trac.wildfiregames.com/export/HEAD/ps/trunk/binaries/system
REM bitsadmin /transfer 0adDownload %URL%/SHA256SUMS %cd%\SHA256SUMS
REM curl.exe -k -L -s %URL%/SHA256SUMS

SETLOCAL EnableDelayedExpansion
for /f "tokens=*" %%l in (SHA256SUMS) do (
  for /f "tokens=1 delims= " %%i in ("%%l") DO (
	set hash=%%i
  )
  for /f "tokens=2 delims= " %%i in ("%%l") DO (
	set filename=%%i
	if "*"=="!filename:~0,1!" set filename=!filename:~1!
  )
  if exist !filename! (
    call :getfilehash
	call :testfilehash
  ) else (
	call :testfilehash
    call :getfilehash
    echo !filename!: Hash !filehash!
  )
)
ENDLOCAL

:getfilehash
set line=0
for /F "delims=" %%i in ('certutil.exe -hashfile !filename! SHA256') do (
  set /a line+=1
  if !line!==2 set filehash=%%i
)
goto :eof

:testfilehash
if !hash!==!filehash! (
  echo !filename!: OK
) else (
  echo !filename!: FAILED
  REM bitsadmin /transfer 0adDownload %URL%/!filename! %cd%\!filename!
  curl.exe -k -L -s %URL%/!filename! -o !filename!
)
goto :eof

:UnZipFile <ExtractTo> <zipfile>
set vbs="%temp%\_.vbs"
if exist %vbs% del /f /q %vbs%
>>%vbs% echo set objShell = CreateObject("Shell.Application")
>>%vbs% echo set FilesInZip=objShell.NameSpace(%2).items
>>%vbs% echo objShell.NameSpace(%1).CopyHere(FilesInZip)
>>%vbs% echo Set objShell = Nothing
cscript //nologo %vbs%
if exist %vbs% del /f /q %vbs%